'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _taggedTemplateLiteral2 = require('babel-runtime/helpers/taggedTemplateLiteral');

var _taggedTemplateLiteral3 = _interopRequireDefault(_taggedTemplateLiteral2);

var _templateObject = (0, _taggedTemplateLiteral3.default)(['\n    Asset manifest file not found.\n      Env: ', '\n      Missing file: ', '\n      You must run webpack (ensure correct environment and webpackerator config).\n      Run ', '\n      You must run your Node.js server with the correct USE_VENDOR_DLL env var.\n  '], ['\n    Asset manifest file not found.\n      Env: ', '\n      Missing file: ', '\n      You must run webpack (ensure correct environment and webpackerator config).\n      Run ', '\n      You must run your Node.js server with the correct USE_VENDOR_DLL env var.\n  ']),
    _templateObject2 = (0, _taggedTemplateLiteral3.default)(['\n      Asset manifest file not found.\n        Env: ', '\n        Missing file: ', '\n        You must build the webpack vendor dll (ensure correct environment and webpackerator config).\n        Run ', '\n  '], ['\n      Asset manifest file not found.\n        Env: ', '\n        Missing file: ', '\n        You must build the webpack vendor dll (ensure correct environment and webpackerator config).\n        Run ', '\n  ']);

////////////////////////////////////////////////////////////////////////////////

// Old settings

//const base = config.envProps.serveAssetsFromWebpackDevServer ? 'http://0.0.0.0:8081/build' : '/assets'
//const base = config.envProps.DEBUG ? 'http://172.168.0.110:8081' : '/assets'

// TODO(vjpr): This should be configurable so we can easily disable the vendor
// dll.
//   Don't use `envProps.DEBUG`. Use something like `USE_VENDOR_DLL`.
// Sync to webpackerator setting.

// Use precompiled dll in development.
//vendorBundleJs: config.envProps.DEBUG ? buildNoProxy + '/vendor.dll.js' : base + '/vendor.bundle.js',
// vendorBundleJs: base + '/vendor.bundle.js', // DEBUG

////////////////////////////////////////////////////////////////////////////////

// TODO(vjpr): Make this much more generic and bundle-aware.

exports.default = function (opts) {

  // Config
  ////////////////////

  var isDev = opts.isDev;
  var buildPath = opts.buildPath;
  var buildDir = opts.buildDir;

  // NOTE: In DEBUG mode we proxy asset requests to webpack dev server.
  // This setting will use a simple static web server.
  // See `live-static`.

  var noProxy = true;

  var buildNoProxyPath = 'build-noproxy';

  // TODO(vjpr): Get from webpackerator or configurize.
  var useVendorDll = process.env.USE_VENDOR_DLL;
  var env = opts.env;

  ////////////////////

  // TODO(vjpr): It may happen that the user runs `npm start` without
  //   webpack-dev-server running and they have not compiled the vendor dll.
  //   We need to check this.
  //   There are methods in webpackerator for this.

  ////////////////////

  var json = void 0;

  if (useVendorDll) {

    var envOpts = void 0;

    envOpts = { compileVendorDll: true, vendorChunkOrDll: 'dll', env: env };
    var vendorDllFileName = getAssetManifestFilename(envOpts);
    var vendorJson = getAssetManifestVendorDllJson({ fileName: vendorDllFileName, env: env, buildPath: buildPath, envOpts: envOpts });

    envOpts = { compileVendorDll: false, vendorChunkOrDll: 'dll', env: env };
    var otherFileName = getAssetManifestFilename(envOpts);
    var otherJson = getAssetManifestJson({ fileName: otherFileName, env: env, buildPath: buildPath, envOpts: envOpts });
    // TODO(vjpr): Do we need to pass something to handle merging arrays?
    //   What about nesting?

    json = _lodash2.default.merge(vendorJson, otherJson);
  } else {

    var _envOpts = { compileVendorDll: false, vendorChunkOrDll: 'chunk', env: env };
    var fileName = getAssetManifestFilename(_envOpts);

    json = getAssetManifestJson({ fileName: fileName, env: env, buildPath: buildPath, envOpts: _envOpts });
  }

  return json;
};

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _cwd = require('cwd');

var _cwd2 = _interopRequireDefault(_cwd);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _zog = require('zog');

var _dedentJs = require('dedent-js');

var _dedentJs2 = _interopRequireDefault(_dedentJs);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _tildify = require('tildify');

var _tildify2 = _interopRequireDefault(_tildify);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

////////////////////////////////////////////////////////////////////////////////

// TODO(vjpr): Should be shared with `live-frontend`.
function getAssetManifestFilename(_ref) {
  var compileVendorDll = _ref.compileVendorDll;
  var vendorChunkOrDll = _ref.vendorChunkOrDll;
  var env = _ref.env;

  var filename = 'webpack-assets';
  if (compileVendorDll) {
    filename += '.vendor-dll';
  } else {
    filename += '.vendor-as-' + vendorChunkOrDll;
  }
  filename += '.' + env + '.json';
  return filename;
}

function getAssetManifestJson(_ref2) {
  var fileName = _ref2.fileName;
  var env = _ref2.env;
  var buildPath = _ref2.buildPath;
  var envOpts = _ref2.envOpts;

  var file = (0, _path.join)(buildPath, fileName);
  var missingMessage = (0, _dedentJs2.default)(_templateObject, _chalk2.default.dim((0, _stringify2.default)(envOpts)), _chalk2.default.dim(file), _chalk2.default.dim('NODE_ENV=' + env + ' gulp webpack:dev-server'));
  assertExists({ file: file, missingMessage: missingMessage });
  var json = _fsExtra2.default.readJsonSync(file);
  return json;
}

function getAssetManifestVendorDllJson(_ref3) {
  var fileName = _ref3.fileName;
  var env = _ref3.env;
  var envOpts = _ref3.envOpts;
  var buildPath = _ref3.buildPath;
  var buildDir = _ref3.buildDir;
  var noProxy = _ref3.noProxy;
  var buildNoProxyPath = _ref3.buildNoProxyPath;

  var file = (0, _path.join)(buildPath, fileName);
  var missingMessage = (0, _dedentJs2.default)(_templateObject2, _chalk2.default.dim((0, _stringify2.default)(envOpts)), _chalk2.default.dim(file), _chalk2.default.dim('NODE_ENV=' + env + ' MAKE_DLL=1 gulp webpack:build'));
  assertExists({ file: file, missingMessage: missingMessage });
  var json = _fsExtra2.default.readJsonSync(file);
  if (noProxy) {
    json.vendor.js = json.vendor.js.replace(buildDir, buildNoProxyPath);
  }
  return json;
}

function assertExists(_ref4) {
  var file = _ref4.file;
  var missingMessage = _ref4.missingMessage;

  if (_fsExtra2.default.existsSync(file)) return;
  (0, _zog.error)(missingMessage);
  throw new Error(missingMessage);
}
module.exports = exports['default'];
//# sourceMappingURL=get-webpack-assets.js.map
