// @flow weak
import React, {Component} from 'react'
import ReactDOM from 'react-dom'
import serialize from 'serialize-javascript'
import {opengraph, twitter} from './header-util'

//
// Wrapper component containing HTML metadata and boilerplate tags.
// Used in server-side code only to wrap the string output of the
// rendered route component.
//
// The only thing this component doesn't (and can't) include is the
// HTML doctype declaration, which is added to the rendered output
// by the server.js file.
//
export class Html extends Component {

  static propTypes:{
    component: any;
    store: any;
    js: Array<string>;
    css: Array<string>;
    title: string;
    loadingComponent: any;
  };

  js() {
    return (
      <div>
        {this.props.js.map((src, i) =>
          <script src={src} key={i} defer></script>
        )}
      </div>
    )
  }

  css() {
    return this.props.css.map((href, i) =>
      <link
        href={href}
        key={i}
        media='screen, projection'
        rel='stylesheet'
        type='text/css'
      />
    )
  }

  renderHeader({title}) {
    return (
      <head>
        <meta charSet='utf-8'/>
        <title>{title}</title>
        {/*opengraph(title, description, image)*/}
        {/*twitter(title, description, image, conf)*/}
        <link rel='shortcut icon' href='/favicon.ico'/>
        {this.css()}
      </head>
    )
  }

  render() {
    const {webpackStats, component, store, title, loadingComponent} = this.props
    const lang = 'en-us'
    const html = (
      <html lang={lang}>
        {this.renderHeader({title})}
        <body>
          <div id='app'>
            <loadingComponent/>
          </div>
          {/*<div id='app' dangerouslySetInnerHTML={{__html: React.renderToString(component)}}/>*/}
          {/*<script dangerouslySetInnerHTML={{__html: `window.__data=${serialize(store.getState())}`}}/>*/}
          {this.js()}
        </body>
      </html>
    )
    return html
  }
}
