// @flow weak
import {debug} from 'zog'
import Koa from 'koa'
import Router from 'koa-router'
import {promisify} from 'bluebird'
import {config} from 'configurize'
import {Html} from './html'
import serverRendering from './server-rendering'
import renderAppHtml from './render-app-html'
import getWebpackAssets from './get-webpack-assets'
//import {protect} from 'app-auth'
import {protect} from './protect'
//import {hookRequire, reportRequire} from 'require-clock'
//import PrettyError from 'pretty-error'
//const pretty = new PrettyError

export class AppFrontend {

  constructor() {

  }

  getApp(rootRoute, store, loadingComponent) {

    const app = new Koa

    // TODO(vjpr): This is not ready.
    //app.use(protect({
    //  urlPattern: /^((?!landing|login|demokit|signup|admin).)*$/gi
    //}))

    app.use(async (ctx, next) => {
      if (ctx.originalUrl == '/') {
        ctx.redirect('/app')
      } else {
        await next()
      }
    })

    const router = new Router

    // TODO(vjpr): Fix.
    router.get(/\/app*|\/login|\/admin|\/signup|\/demokit|\/demo*/, async (ctx, next) => {
    //router.get(/\/app*/, async (ctx, next) => {

      // TODO(vjpr): Get env from somewhere properly.
      let opts = {
        env: process.env.NODE_ENV || 'development',
        watchLivePluginFiles: false,
      }

      const webpackeratorUtils = require('webpackerator/lib/webpack')
      opts = webpackeratorUtils.parseOpts(opts)

      // TODO(vjpr): This modifies the file system which dirties the
      //   cache, causing a rebuild on every request if activated.
      //const webpackConfig = webpackeratorUtils.getConfig(opts)

      //config.print()

      const routes = rootRoute
      const store = store

      const webpackAssets = getWebpackAssets(opts)
      const useServerSideRendering = false
      const html = await renderAppHtml({
        isDev: opts.isDev,
        routes,
        store,
        webpackAssets,
        useServerSideRendering,
        publicDir: config.get('app-frontend.publicDir', '/public'),
        appTitle: config.get('app-frontend.appTitle'),
        loadingComponent,
      })
      ctx.body = html
      debug('Render frontend complete')

    })

    app.use(router.routes())

    return app

  }

}

