import Spinner from './spinner'
import {getCallerFile} from 'live-caller'

export default class {

  desc = 'Isomorphic web app routes';

  services = {
    consume: {
      'live-react-router.rootRoute': {'^1.0.0': 'consumeReactRouterRootRoute'},
      'app-redux.store': {'^1.0.0': 'consumeReduxStore'},
      'app-server.service': {'^1.0.0': 'consumeAppServerService'},
    },
    provide: {
      'live-frontend.service': {'1.0.0': 'provideService'},
    },
  };

  provideService() {
    return {}
  }

  consumeReactRouterRootRoute(routes) {
    this.routes = routes
  }

  consumeReduxStore(store) {
    this.store = store
  }

  consumeAppServerService(service) {
    service.addMiddleware(this.constructor.getRoute())
  }

  static getRoute() {
    const mount = require('koa-mount-hot')
    const loadingComponent = Spinner
    const opts = {
      path: require.resolve('./index'),
      require: (req) => {
        const mod = new (require(req).AppFrontend)
        return mod.getApp(this.routes, this.store, loadingComponent)
      },
    }
    const mw = mount('/', opts)
    mw._name = 'live-frontend /'
    return mw
  }


}
